// file:09_data_basic/9_5_randomwalk

let pos = [];

function setup() {
  createCanvas(400, 400);
  noFill();
  strokeWeight(1);
  for (let i = 0; i < 100; i++) {
    pos[i] = {
      x: random(width),
      y: random(height),
      radius: random(),
      speed: random(),
      angle: random(TWO_PI),
      color: color(random(255), random(255), random(255)) // ポイントごとに異なる色
    };
  }
}


function draw() {
  background(0, 0, 40);
  for (let i = 0; i < 100; i++) {
    stroke(pos[i].color);
    let currentRadius = pos[i].radius + sin(frameCount * pos[i].speed) * 20;
    ellipse(pos[i].x, pos[i].y, currentRadius);
    let stepSize = random(0.5, 2);
    pos[i].x += cos(pos[i].angle) * stepSize;
    pos[i].y += sin(pos[i].angle) * stepSize;
    pos[i].angle += random(-0.1, 0.1);
    pos[i].x = (pos[i].x + width) % width;
    pos[i].y = (pos[i].y + height) % height;
  }
}
