// file:11_function/11_2_argument

let circles = [];
let circleColors = ['#F38181', '#FCE38A', '#EAFFD0', '#95E1D3'];
function setup() {
  createCanvas(800, 600);
  for (let i = 0; i < 70; i++) {
    let circle = {
      x: random(width),
      y: random(height),
      radius: random(30),
      fillColor: color(random(circleColors)),
      speedX: random(-2, 2),
      speedY: random(-2, 2)
    };
    circles.push(circle);
  }
}

function draw() {
  background(250);

  for (let i = 0; i < circles.length; i++) {
    let circle = circles[i];

    circle.x += circle.speedX;
    circle.y += circle.speedY;

    bounceOffEdges(circle);

    fill(circle.fillColor);
    ellipse(circle.x, circle.y, circle.radius, circle.radius);
  }

  drawConnectingLines();
}

function bounceOffEdges(circle) {
  if (circle.x - circle.radius < 0 || circle.x + circle.radius > width) {
    circle.speedX *= -1;
  }
  if (circle.y - circle.radius < 0 || circle.y + circle.radius > height) {
    circle.speedY *= -1;
  }
}

function drawConnectingLines() {
  for (let i = 0; i < circles.length; i++) {
    for (let j = i + 1; j < circles.length; j++) {
      let distance = dist(circles[i].x, circles[i].y, circles[j].x, circles[j].y);
      if (distance < 100) {
        stroke(color('#95E1D3'));
        line(circles[i].x, circles[i].y, circles[j].x, circles[j].y);
      }
    }
  }
}
