// file:11_function/11_3_returnValue

let circles = [];

function setup() {
  createCanvas(600, 600);
  colorMode(HSB, 360, 100, 100, 100);
  noStroke();
  for (let i = 0; i < 150; i++) {
    let circle = createBouncingCircle();
    circles.push(circle);
  }
}

function draw() {
  background(0, 15);
  for (let circle of circles) {
    moveBouncingCircle(circle);
    drawBouncingCircle(circle);
  }
}

function createBouncingCircle() {
  return {
    pos: createVector(width / 2, height / 2),
    col: color(random(360), random(50, 100), random(50, 100)),
    size: random(5, 25),
    velocity: createVector(random(-3, 3), random(-3, 3)),
  };
}

function moveBouncingCircle(circle) {
  circle.pos.add(circle.velocity);

  if (circle.pos.x + circle.size / 2 > width || circle.pos.x - circle.size / 2 < 0) {
    circle.velocity.x *= -1;
  }

  if (circle.pos.y + circle.size / 2 > height || circle.pos.y - circle.size / 2 < 0) {
    circle.velocity.y *= -1;
  }
}

function drawBouncingCircle(circle) {
  fill(circle.col);
  ellipse(circle.pos.x, circle.pos.y, circle.size);
}
