// file:12_class/12_2_rotatingCircle_2

let circles = [];
function setup(){
    createCanvas(windowWidth, windowHeight);
    colorMode(HSB);
    strokeWeight(1.5);
    for(let i = 1; i < 4; i++){
      let circle = new RotatingCircle(i*0.75, i*50);
      circles.push(circle)
    }
}
function draw(){
    background(255);
    for(let circle of circles){
      circle.rotate();
      circle.draw();
    }
}

class RotatingCircle{
    constructor(rSpeed, rSize){
    this.x = 0,
    this.y = 0,
    this.size = 30,
    this.angle = 0,
    this.rotatingSpeed = rSpeed,
    this.rotatingSize = rSize,
    this.color = color(0, 100, 100)
    }
    rotate(){
        this.angle += this.rotatingSpeed;
        this.x = cos(radians(this.angle)) * this.rotatingSize + mouseX;
        this.y = sin(radians(this.angle)) * this.rotatingSize + mouseY;
    }
    draw(){
        //軌道の輪の描画
        noFill();
        stroke(0);
        ellipse(mouseX, mouseY, this.rotatingSize*2);

        this.color = color(this.angle%360, 100, 100);

        //円の描画
        fill(this.color);
        noStroke()
        ellipse(this.x, this.y, this.size);
    }
}
