// file:12_class/12_5_dist

let circles = [];

function setup() {
  createCanvas(windowWidth, windowHeight);
  stroke(255);
}

function draw() {
  background(0, 0, 40);
  if (mouseIsPressed) {
    circles.push(new Circle(mouseX, mouseY));
    if (circles.length > 100) {
      circles.splice(0, 1);
    }
  }
  for (let circle of circles) {
    circle.move();
    circle.draw();
    for (let otherCircle of circles) {
      if (circle !== otherCircle) {
        let position1 = circle.position;
        let position2 = otherCircle.position;
        let distance = dist(
          position1.x, position1.y,
          position2.x, position2.y
        );

        if (distance < 100) {
          line(position1.x, position1.y, position2.x, position2.y);
        }
      }
    }
  }
}

class Circle {
  constructor(x, y) {
    this.position = createVector(x, y);
    this.velocity = createVector(random(-3, 3), random(-3, 3));
    this.size = random(3, 10);
  }

  move() {
    this.position.add(this.velocity);
  }

  draw() {
    ellipse(this.position.x, this.position.y, this.size);
  }
}
