let circles = [];

function setup() {
  createCanvas(400, 400);
  noFill();
  circles = [];
  for (let i = 0; i < 250; i++) {
    circles[i] = {
      x: random(width),
      y: random(height),
      radius: random(1, 20),
      speed: random(0.05, 0.1),
      angle: random(TWO_PI),
      color: color(random(255), random(255), random(255)),
    };
  }
}

function draw() {
  background(0);
  for (let i = 0; i < 250; i++) {
    stroke(circles[i].color);
    let currentRadius =
      circles[i].radius + cos(frameCount * circles[i].speed) * 20; //①
    ellipse(circles[i].x, circles[i].y, currentRadius);
    circles[i].x += cos(circles[i].angle);
    circles[i].y += sin(circles[i].angle);
    circles[i].angle += random(-0.1, 0.1); //②
    circles[i].x = (circles[i].x + width) % width;
    circles[i].y = (circles[i].y + height) % height;
  }
}
