let circles = [];

function setup() {
  createCanvas(800, 600);
  noStroke();
  for (let i = 0; i < 50; i++) {
    createRandomCircle();
  }
}

function draw() {
  background(10, 10, 30, 10);
  for (let circle of circles) {
    updateCircle(circle);
    drawCircle(circle);
  }
}

function createRandomCircle() {
  let circle = {
    x: width / 2,
    y: height / 2,
    radius: 8 + random(12),
    hue: random(360),
    saturation: random(30, 70),
    brightness: random(50, 90),
    angleX: random(TWO_PI),
    angleY: random(TWO_PI),
    angleSpeedX: random(0.005, 0.03),
    angleSpeedY: random(0.005, 0.03),
  };
  circles.push(circle);
}

function updateCircle(circle) {
  circle.x = width / 2 + cos(circle.angleX) * 250;
  circle.y = height / 2 + sin(circle.angleY) * 250;
  circle.angleX += circle.angleSpeedX;
  circle.angleY += circle.angleSpeedY;
}

function drawCircle(circle) {
  fill(circle.hue, circle.saturation, circle.brightness);
  ellipse(circle.x, circle.y, circle.radius * 2, circle.radius * 2);
}
