let circles = [];
let colors = ["#3081D0", "#FFF5C2", "#F4F27E", "#6DB9EF"];

function setup() {
  createCanvas(400, 400);
  noStroke();
}

function draw() {
  background(250, 30);

  for (let i = 0; i < circles.length; i++) {
    circles[i].update();
    circles[i].display();
  }

  circles = circles.filter((circle) => circle.radius < 150);

  if (random() > 0.97) {
    let x = random(width);
    let y = random(height);
    let col = color(random(colors));
    let radius = 5;
    circles.push(new GrowingCircle(x, y, radius, col));
  }
}

class GrowingCircle {
  constructor(x, y, radius, col) {
    //①
    this.position = createVector(x, y);
    this.radius = radius;
    this.col = col;
  }

  update() {
    //②
    this.radius += 0.5;
  }

  display() {
    //③
    fill(this.col);
    ellipse(this.position.x, this.position.y, this.radius * 2, this.radius * 2);
  }
}
