let particles = [];

function setup() {
  createCanvas(windowWidth, windowHeight);
  noStroke();
}

function draw() {
  background(0);
  for (let particle of particles) {
    particle.move();
    particle.draw();
  }

  particles = particles.filter((particle) => particle.lifetime > 0);

  if (mouseIsPressed) {
    for (let i = 0; i < 3; i++) {
      particles.push(new Particle(mouseX, mouseY));
    }
  }
}

class Particle {
  constructor(x, y) {
    //①
    this.position = createVector(x, y);
    this.velocity = createVector(random(-3, 3), random(-5, -10));
    this.velocity.mult(random(1, 5));
    this.color = [random(255), random(200, 255), 255];
    this.lifetime = 100;
  }

  move() {
    //②
    this.position.add(this.velocity);
    this.velocity.y++;
    this.lifetime--;
  }

  draw() {
    //③
    fill(this.color);
    ellipse(this.position.x, this.position.y, random(20));
  }
}
