let particles = [];

function setup() {
  createCanvas(windowWidth, windowHeight);
  stroke(255, 10);
  noFill();
  rectMode(CENTER);
}

function draw() {
  background(0, 20);
  if (mouseIsPressed) {
    for (let i = 0; i < 10; i++) {
      particles.push(new Particle(mouseX, mouseY));
    }
  }

  for (let particle of particles) {
    particle.move();
    particle.draw();
  }
  particles = particles.filter((particle) => particle.lifetime > 0);
}

class Particle {
  constructor(x, y) {
    //①
    this.position = createVector(x, y);
    this.speed = random(0.1, 5);
    this.velocity = createVector(random(-1, 1), random(-1, 1));
    this.rotation = random(TWO_PI);
    this.rotateSpeed = random(-0.001, 0.005);
    this.size = random(1, 70);
    this.lifetime = random(100, 150);
  }

  move() {
    //②
    this.rotation += this.rotateSpeed;
    this.velocity.x = this.speed * cos(this.rotation);
    this.velocity.y = this.speed * sin(this.rotation);
    this.position.add(this.velocity);
    this.size *= 0.995;
    this.lifetime--;
  }

  draw() {
    //③
    rect(this.position.x, this.position.y, this.size, this.size);
  }
}
