let flies = [];

function add_fly(x, y) {
  flies.push({
    x: x,
    y: y,
    sx: random(5),
    sy: random(5),
    a: random(360),
  });
}

function setup() {
  createCanvas(400, 400);
  noStroke();
  for (let i = 0; i < 30; i++) {
    add_fly(random(100, 300), random(100, 300));
  }
}

function draw() {
  background(0, 0, 0, 30);

  for (let f of flies) {
    f.x += map(noise(f.sx), 0, 1, -2, 2);
    f.y += map(noise(f.sy), 0, 1, -2, 2);
    f.sx += 0.01;
    f.sy += 0.01;
    f.a += 2;
    alpha = map(sin(radians(f.a)), -1, 1, 0, 100);
    fill(100, 255, 100, alpha);
    ellipse(f.x, f.y, 4, 4);
  }

  flies = flies.filter(function (f) {
    return 0 < f.x && f.x < width && 0 < f.y && f.y < height;
  });
}

function mousePressed() {
  add_fly(mouseX, mouseY);
}
