let points = [];
let slider_vertex;
let slider_size;

function setup() {
  noStroke();
  slider_vertex = createSlider(3, 100, 3, 1);
  slider_size = createSlider(30, 50, 0, 5);
  slider_vertex.input(updateShape);
  slider_size.input(updateShape);
  createCanvas(400, 400);
  updateShape();
}

function updateShape() {
  points = [];
  let n = slider_vertex.value();
  let theta = radians(360 / n);

  let noiseScale = 0.1;

  for (let i = 0; i < n; i++) {
    let r = noise(i * noiseScale) * slider_size.value() * 5;
    let x = cos(theta * i) * r + 200;
    let y = sin(theta * i) * r + 200;
    points.push(createVector(x, y));
  }
}

function draw() {
  background(255);
  beginShape();
  for (let i = 0; i < points.length; i++) {
    fill(0, 100, 0);
    curveVertex(points[i].x, points[i].y);
  }
  endShape(CLOSE);
}
