let mic;
let circles = [];

function setup() {
  createCanvas(windowWidth, windowHeight);
  fill(25, 225, 25);
  noStroke();
  mic = new p5.AudioIn();
  mic.start();
  for (let i = 0; i < 200; i++) {
    circles.push(new Circle());
  }
}

function draw() {
  background(0, 30);
  let micLevel = mic.getLevel();
  for (let circle of circles) {
    circle.move(micLevel);
    circle.draw();
  }
}

class Circle {
  constructor() {
    this.angle = random(TWO_PI);
    this.radius = random(50, 200);
    this.speed = random(0.01, 0.05);
  }

  move(level) {
    this.angle += this.speed * (1 + level * 10);
  }

  draw() {
    let positionX = cos(this.angle) * this.radius;
    let positionY = sin(this.angle) * this.radius;

    ellipse(width / 2 + positionX, height / 2 + positionY, 5);
  }
}
